
### gil tweaks to original bdf2lvgl code from https://pypi.org/project/bdf2lvgl/


import  logging

import  bdflib.reader

from    parse import parse_font

import  codegen as cg

# -----------------------------------------------------------
# >>>>> enter bdf font to convert (no extension):
# (or you can get fancy and read all the files)

font_name = 'bmfont_16px_8x16_tamzen'

# -----------------------------------------------------------


input =             f'./fonts_in/{font_name}.bdf'
output =            f'./fonts_out/{font_name}.c'
name =              f'{font_name}'
min_dense_run =     1

try:
    print('read_bdf')
    font = bdflib.reader.read_bdf(open(input, 'rb'))
    assert font is not None
except AssertionError as e:
    logging.fatal(f'Failed to parse bdf; error: {e}')

parsed = parse_font(font, name=name, min_dense_run=min_dense_run)
if not output:
    output = parsed['name'] + '.c'

with open(output, 'w', encoding='utf8') as fout:
    fout.write(cg.gen_lv_font(parsed))
